# class ActionDispatch::Flash

The flash provides a way to pass temporary objects between actions. Anything you place in the flash will be exposed to the very next action and then cleared out. This is a great way of doing notices and alerts, such as a create action that sets `flash[:notice] = "Post successfully created"` before redirecting to a display action that can then expose the flash to its template. Actually, that exposure is automatically done. Example:

    class PostsController < ActionController::Base
      def create
        # save post
        flash[:notice] = "Post successfully created"
        redirect_to posts_path(@post)
      end

      def show
        # doesn't need to assign the flash notice to the template, that's done automatically
      end
    end

    show.html.erb
      <% if flash[:notice] %>
        <div class="notice"><%= flash[:notice] %></div>
      <% end %>

Since the `notice` and `alert` keys are a common idiom, convenience accessors are available:

    flash.alert = "You must be logged in"
    flash.notice = "Post successfully created"

This example just places a string in the flash, but you can put any object in there. And of course, you can put as many as you like at a time too. Just remember: They’ll be gone by the time the next action has been performed.

See docs on the FlashHash class for more details about the flash.

### Constants

KEY

### Public Class Methods

new(app) click to toggle source

    # File lib/action_dispatch/middleware/flash.rb, line 233
    def initialize(app)
      @app = app
    end

### Public Instance Methods

call(env) click to toggle source

    # File lib/action_dispatch/middleware/flash.rb, line 237
    def call(env)
      if (session = env['rack.session']) && (flash = session['flash'])
        flash.sweep
      end

      @app.call(env)
    ensure
      session    = env['rack.session'] || {}
      flash_hash = env[KEY]

      if flash_hash
        if !flash_hash.empty? || session.key?('flash')
          session["flash"] = flash_hash
          new_hash = flash_hash.dup
        else
          new_hash = flash_hash
        end

        env[KEY] = new_hash
      end

      if session.key?('flash') && session['flash'].empty?
        session.delete('flash')
      end
    end